// File: MultNode.java
import antlr.*;
import antlr.collections.AST;

public class MultNode extends BinaryOperatorAST {

  public MultNode(Token token) {
    super(token);
  }

  public int getType() {
    return CalcParserTokenTypes.STAR;
  }

  public String toString() {
    return " *";
  }

  public int value() {
    return left().value() * right().value();
  }

} // class MultNode
