// File: UnaryMinusNode.java
import antlr.*;
import antlr.collections.AST;

public class UnaryMinusNode extends CalcAST {

  public UnaryMinusNode(Token token) {
    super(token);
    System.out.println("UnaryMinusNode(" + token + ") constructor");
  }

  public int getType() {
    return CalcParserTokenTypes.UNARY_MINUS;
  }

  public String toString() {
    return " - " + ((CalcAST) getFirstChild()).toString();
  }

  public int value() {
    System.out.println("UnaryMinusNode.value()");

    int val = ((CalcAST) getFirstChild()).value();
    System.out.println("UnaryMinusNode.value(): " + -val);
    return -val;
  }

} // class UnaryMinusNode

