// File: IntNode
import antlr.*;
import antlr.collections.AST;

public class CharNode extends CalcAST {

  public CharNode(Token token) {
    super(token);
  }

  public int getType() {
    return CalcParserTokenTypes.CHAR;
  }

  public String toString() {
    return token.getText();
  }

  public int value() {
	return 0;
  }

} // class IntNode

