// File: DivNode.java
import antlr.*;
import antlr.collections.AST;

public class DivNode extends BinaryOperatorAST {

  public DivNode(Token token) {
    super(token);
  }

  public int getType() {
    return CalcParserTokenTypes.DIV;
  }

  public String toString() {
    return " /";
  }

  public int value() {
    return left().value() / right().value();
  }

} // class DivNode

