// File: BinaryOperatorAST.java
import antlr.*;
import antlr.collections.AST;

public abstract class BinaryOperatorAST extends CalcAST {

  public BinaryOperatorAST(Token token) {
    super(token);
  }

  public CalcAST left() {
    return (CalcAST) getFirstChild();
  }

  public CalcAST right() {
    CalcAST t = left();
    if (t == null) {
      return null;
    }
    return (CalcAST) t.getNextSibling();
  }

} // class BinaryOperatorAST
