// File: IntNode
import antlr.*;
import antlr.collections.AST;

public class IntNode extends CalcAST {

  public IntNode(Token token) {
    super(token);
  }

  public int getType() {
    return CalcParserTokenTypes.INT;
  }

  public String toString() {
    return " " + value();
  }

  public int value() {
    return Integer.parseInt(token.getText());
  }

} // class IntNode

