// File: CalcAST.java
import antlr.*;
import antlr.collections.AST;

public class CalcAST extends BaseAST {
  protected Token token;

  public CalcAST() {
  } // constructor

  public CalcAST(Token token) {
    this.token = token;
//    System.out.println("CalcAST(" + token + ") constructor");
  } // constructor

  public String getText() {
    if (this.token == null) {
      System.out.println("null token in CalcAST.getText()");
      return "";
    }
    return token.getText();
  }

  // satisfy abstract methods from BaseAST
  public void initialize(int parm1, String parm2) { }
  public void initialize(Token parm1) { }
  public void initialize(AST parm1) { }

  public int value() { return 0; }

} // class CalcAST

