// $ANTLR 2.7.5 (20050128): "calc.g" -> "CalcParser.java"$

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import java.util.Hashtable;
import antlr.ASTFactory;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

public class CalcParser extends antlr.LLkParser       implements CalcParserTokenTypes
 {

protected CalcParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public CalcParser(TokenBuffer tokenBuf) {
  this(tokenBuf,4);
}

protected CalcParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public CalcParser(TokenStream lexer) {
  this(lexer,4);
}

public CalcParser(ParserSharedInputState state) {
  super(state,4);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

	public final void expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		CalcAST expression_AST = null;
		
		logicalExpression();
		astFactory.addASTChild(currentAST, returnAST);
		match(SEMI);
		expression_AST = (CalcAST)currentAST.root;
		returnAST = expression_AST;
	}
	
	public final void logicalExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		CalcAST logicalExpression_AST = null;
		
		relExpression();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop5:
		do {
			if ((LA(1)==AND||LA(1)==OR)) {
				{
				switch ( LA(1)) {
				case AND:
				{
					CalcAST tmp2_AST = null;
					tmp2_AST = (CalcAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp2_AST);
					match(AND);
					break;
				}
				case OR:
				{
					CalcAST tmp3_AST = null;
					tmp3_AST = (CalcAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp3_AST);
					match(OR);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				relExpression();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop5;
			}
			
		} while (true);
		}
		logicalExpression_AST = (CalcAST)currentAST.root;
		returnAST = logicalExpression_AST;
	}
	
	public final void relExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		CalcAST relExpression_AST = null;
		
		simpleExpression();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop9:
		do {
			if (((LA(1) >= LT && LA(1) <= NEQ))) {
				{
				switch ( LA(1)) {
				case LT:
				{
					CalcAST tmp4_AST = null;
					tmp4_AST = (CalcAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp4_AST);
					match(LT);
					break;
				}
				case LE:
				{
					CalcAST tmp5_AST = null;
					tmp5_AST = (CalcAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp5_AST);
					match(LE);
					break;
				}
				case EQ:
				{
					CalcAST tmp6_AST = null;
					tmp6_AST = (CalcAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp6_AST);
					match(EQ);
					break;
				}
				case GE:
				{
					CalcAST tmp7_AST = null;
					tmp7_AST = (CalcAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp7_AST);
					match(GE);
					break;
				}
				case GT:
				{
					CalcAST tmp8_AST = null;
					tmp8_AST = (CalcAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp8_AST);
					match(GT);
					break;
				}
				case NEQ:
				{
					CalcAST tmp9_AST = null;
					tmp9_AST = (CalcAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp9_AST);
					match(NEQ);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				simpleExpression();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop9;
			}
			
		} while (true);
		}
		relExpression_AST = (CalcAST)currentAST.root;
		returnAST = relExpression_AST;
	}
	
	public final void simpleExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		CalcAST simpleExpression_AST = null;
		Token  m = null;
		MinusNode m_AST = null;
		
		switch ( LA(1)) {
		case MINUS:
		{
			m = LT(1);
			m_AST = (MinusNode)astFactory.create(m,"MinusNode");
			astFactory.makeASTRoot(currentAST, m_AST);
			match(MINUS);
			term();
			astFactory.addASTChild(currentAST, returnAST);
			m_AST.setType(UNARY_MINUS);
			
			System.out.println("Got unary");
			//      #simpleExpression = #([UNARY_MINUS, "-"], #t);
			
			//       #simpleExpression = antlr.ASTFactory.create(new UnaryMinusNode(LT(1))), #t);
			//       #simpleExpression = new UnaryMinusNode(t);
			
			simpleExpression_AST = (CalcAST)currentAST.root;
			break;
		}
		case INT:
		case CHAR:
		case LPAREN:
		{
			term();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop13:
			do {
				if ((LA(1)==PLUS||LA(1)==MINUS)) {
					{
					switch ( LA(1)) {
					case PLUS:
					{
						PlusNode tmp10_AST = null;
						tmp10_AST = (PlusNode)astFactory.create(LT(1),"PlusNode");
						astFactory.makeASTRoot(currentAST, tmp10_AST);
						match(PLUS);
						break;
					}
					case MINUS:
					{
						MinusNode tmp11_AST = null;
						tmp11_AST = (MinusNode)astFactory.create(LT(1),"MinusNode");
						astFactory.makeASTRoot(currentAST, tmp11_AST);
						match(MINUS);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					term();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop13;
				}
				
			} while (true);
			}
			simpleExpression_AST = (CalcAST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = simpleExpression_AST;
	}
	
	public final void term() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		CalcAST term_AST = null;
		
		factor();
		astFactory.addASTChild(currentAST, returnAST);
		{
		_loop17:
		do {
			if ((LA(1)==STAR||LA(1)==DIV)) {
				{
				switch ( LA(1)) {
				case STAR:
				{
					MultNode tmp12_AST = null;
					tmp12_AST = (MultNode)astFactory.create(LT(1),"MultNode");
					astFactory.makeASTRoot(currentAST, tmp12_AST);
					match(STAR);
					break;
				}
				case DIV:
				{
					DivNode tmp13_AST = null;
					tmp13_AST = (DivNode)astFactory.create(LT(1),"DivNode");
					astFactory.makeASTRoot(currentAST, tmp13_AST);
					match(DIV);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				factor();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				break _loop17;
			}
			
		} while (true);
		}
		term_AST = (CalcAST)currentAST.root;
		returnAST = term_AST;
	}
	
	public final void factor() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		CalcAST factor_AST = null;
		
		switch ( LA(1)) {
		case INT:
		{
			IntNode tmp14_AST = null;
			tmp14_AST = (IntNode)astFactory.create(LT(1),"IntNode");
			astFactory.addASTChild(currentAST, tmp14_AST);
			match(INT);
			factor_AST = (CalcAST)currentAST.root;
			break;
		}
		case LPAREN:
		{
			match(LPAREN);
			logicalExpression();
			astFactory.addASTChild(currentAST, returnAST);
			match(RPAREN);
			factor_AST = (CalcAST)currentAST.root;
			break;
		}
		case CHAR:
		{
			CharNode tmp17_AST = null;
			tmp17_AST = (CharNode)astFactory.create(LT(1),"CharNode");
			astFactory.addASTChild(currentAST, tmp17_AST);
			match(CHAR);
			factor_AST = (CalcAST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = factor_AST;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"UNARY_MINUS",
		"+",
		"-",
		"*",
		"/",
		"INT",
		"CHAR",
		";",
		"AND",
		"OR",
		"<",
		"<=",
		"=",
		">=",
		">",
		"<>",
		"(",
		")",
		"WS",
		"DIGIT"
	};
	
	protected void buildTokenTypeASTClassMap() {
		tokenTypeToASTClassMap = new Hashtable();
		tokenTypeToASTClassMap.put(new Integer(4), UnaryMinusNode.class);
		tokenTypeToASTClassMap.put(new Integer(5), PlusNode.class);
		tokenTypeToASTClassMap.put(new Integer(6), MinusNode.class);
		tokenTypeToASTClassMap.put(new Integer(7), MultNode.class);
		tokenTypeToASTClassMap.put(new Integer(8), DivNode.class);
		tokenTypeToASTClassMap.put(new Integer(9), IntNode.class);
		tokenTypeToASTClassMap.put(new Integer(10), CharNode.class);
	};
	
	
	}
